#include <sm.h>
#include <pthread.h>
#include <stdio.h>

char *memory;

sm mutex;

void *thread_func_1 (void *arg);
void *thread_func_2 (void *arg);

int
main (void)
{
  pthread_t th1, th2;

  sm_init (&mutex);

  if (!(memory = (char *) malloc (20 * sizeof (char))))
    {
      printf ("malloc");
      return 1;
    }

  if (pthread_create (&th1, NULL, thread_func_1, NULL))
    {
      printf ("pthread_create");
      return 1;
    }

  if (pthread_create (&th2, NULL, thread_func_2, NULL))
    {
      printf ("pthread_create");
      return 1;
    }

  pthread_join (th1, NULL);
  pthread_join (th2, NULL);

  putchar ('\n');
  printf ("Conflitti: %d\n", sm_conflicts (&mutex));

  return 0;
}

void *
thread_func_1 (void *arg)
{

  sm_lock (&mutex);

  memcpy (memory, "Hello", 5);
  printf ("%s ", memory);
  sleep (1);

  sm_unlock (&mutex);

  pthread_exit (0);
}

void *
thread_func_2 (void *arg)
{

  sm_lock (&mutex);

  memcpy (memory, "World", 5);
  printf ("%s ", memory);
  sleep (1);

  sm_unlock (&mutex);

  pthread_exit (0);
}
