#include <sm.h>
#include <pthread.h>
#include <stdio.h>
#include <time.h>

char *memory;

void *thread_func_1 (void *arg);
void *thread_func_2 (void *arg);

int
main (void)
{
  int ret;
  pthread_t th1, th2, th3, th4, th5;

  srand (time (NULL));

  if (!(memory = (char *) malloc (20 * sizeof (char))))
    {
      puts ("malloc");
      return 1;
    }

  ret = sm_cond_init (memory);
  if (ret)
    puts ("Error sm_cond_init");


  if (pthread_create (&th1, NULL, thread_func_1, NULL))
    {
      puts ("pthread_create");
      return 1;
    }

  if (pthread_create (&th2, NULL, thread_func_1, NULL))
    {
      puts ("pthread_create");
      return 1;
    }

  if (pthread_create (&th3, NULL, thread_func_1, NULL))
    {
      puts ("pthread_create");
      return 1;
    }

  if (pthread_create (&th4, NULL, thread_func_1, NULL))
    {
      puts ("pthread_create");
      return 1;
    }

  if (pthread_create (&th5, NULL, thread_func_2, NULL))
    {
      puts ("pthread_create");
      return 1;
    }

  pthread_join (th1, NULL);
  pthread_join (th2, NULL);
  pthread_join (th3, NULL);
  pthread_join (th4, NULL);
  pthread_join (th5, NULL);

  return 0;
}

void *
thread_func_1 (void *arg)
{
  int ret;

  ret = rand () % (int) 10;
  fprintf (stdout, "Sleep %d sec\n", ret);

  sleep (ret);

  puts ("Stop");

  ret = sm_cond_wait (memory);
  if (ret)
    puts ("Error sm_cond_wait");

  puts ("Start");

  pthread_exit (0);
}

void *
thread_func_2 (void *arg)
{
  int ret;

  sleep (10);

  puts ("Signal after 10 sec");

  ret = sm_cond_signal (memory);
  if (ret)
    puts ("Error sm_cond_signal");

  pthread_exit (0);
}
